/* GNU POP3 - a small, fast, and efficient POP3 daemon
   Copyright (C) 1999 Jakob 'sparky' Kaivo <jkaivo@nodomainname.net>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* Written by Joergen Thomsen jth@jth.net Dec. 2000 */

#include "gnu-pop3d.h"

int
pop3_uidl (const char *arg)
{
  int mesg, i;

  if (state != TRANSACTION)
	return ERR_WRONG_STATE;

  if (strchr (arg, ' ') != NULL)	/* more than one arg */
	return ERR_BAD_ARGS;

  if (strlen (arg) == 0)
	{							/* list all unique-ids */
	  fprintf (ofile, "+OK unique-id listing follows\r\n");
	  for (mesg = 0; mesg < num_messages; mesg++)
		{
		  if (pop3_mesg_exist (mesg) == OK)
			{
			  fprintf (ofile, "%d ", mesg + 1);
			  for (i = 0; i < 16; i++)
				fprintf (ofile, "%02x", messages[mesg].md5digest[i]);
			  fprintf (ofile, "\r\n");
			}
		}
	  fprintf (ofile, ".\r\n");
	}
  else
	{
	  mesg = atoi (arg) - 1;

	  if (pop3_mesg_exist (mesg) != OK)
		return ERR_NO_MESG;

	  fprintf (ofile, "+OK %d ", mesg + 1);
	  for (i = 0; i < 16; i++)
		fprintf (ofile, "%02x", messages[mesg].md5digest[i]);
	  fprintf (ofile, "\r\n");

	}

  return OK;

}
